// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-4.2.0/src/iosource/pcap/pcap.bif (alternative mode).


#include "pcap.bif.h"
#include "zeek/Func.h"

namespace zeek { namespace BifConst { namespace Pcap {  bro_uint_t snaplen;  }  } }
namespace BifConst { namespace Pcap {  bro_uint_t snaplen;  }  }
namespace zeek { namespace BifConst { namespace Pcap {  bro_uint_t bufsize;  }  } }
namespace BifConst { namespace Pcap {  bro_uint_t bufsize;  }  }

#line 8 "pcap.bif"

#include <pcap.h>

#include "zeek/iosource/Manager.h"

#line 32 "pcap.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Pcap::precompile_pcap_filter_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 33 "pcap.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		reporter->Error("Pcap::precompile_pcap_filter() takes exactly 2 argument(s)");
		return nullptr;
		}
	zeek::Val* id = (zeek::Val*) ((*BiF_ARGS)[0].get());
	zeek::StringVal* s = (zeek::StringVal*) ((*BiF_ARGS)[1].get()->AsStringVal());

#line 33 "pcap.bif"

	if ( id->AsEnum() >= 100 )
		{
		// We use a vector as underlying data structure for fast
		// lookups and limit the ID space so that that doesn't grow too
		// large.
		zeek::emit_builtin_error(
			zeek::util::fmt("PCAP filter ids must remain below 100 (is %" PRId64 ")", id->AsInt()));
		return zeek::val_mgr->False();
		}

	bool success = true;

	zeek::iosource::PktSrc* ps = zeek::iosource_mgr->GetPktSrc();
	if ( ps && ! ps->PrecompileFilter(id->AsInt(), s->CheckString()) )
		success = false;

	return zeek::val_mgr->Bool(success);
	} // end of BifFunc::Pcap::precompile_pcap_filter

#line 51 "pcap.bif"

#line 71 "pcap.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Pcap::install_pcap_filter_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 72 "pcap.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		reporter->Error("Pcap::install_pcap_filter() takes exactly 1 argument(s)");
		return nullptr;
		}
	zeek::Val* id = (zeek::Val*) ((*BiF_ARGS)[0].get());

#line 72 "pcap.bif"

	bool success = true;

	zeek::iosource::PktSrc* ps = zeek::iosource_mgr->GetPktSrc();
	if ( ps && ! ps->SetFilter(id->AsInt()) )
		success = false;

	return zeek::val_mgr->Bool(success);
	} // end of BifFunc::Pcap::install_pcap_filter

#line 80 "pcap.bif"

#line 96 "pcap.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Pcap::error_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 97 "pcap.bif"
{
	if ( BiF_ARGS->size() != 0 )
		{
		reporter->Error("Pcap::error() takes exactly 0 argument(s)");
		return nullptr;
		}

#line 97 "pcap.bif"

	zeek::iosource::PktSrc* ps = zeek::iosource_mgr->GetPktSrc();
	if ( ps )
		{
		const char* err = ps->ErrorMsg();
		if ( *err )
			return zeek::make_intrusive<zeek::StringVal>(err);
		}

	return zeek::make_intrusive<zeek::StringVal>("no error");
	} // end of BifFunc::Pcap::error

#line 107 "pcap.bif"

#line 109 "pcap.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Pcap::findalldevs_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 110 "pcap.bif"
{
	if ( BiF_ARGS->size() != 0 )
		{
		reporter->Error("Pcap::findalldevs() takes exactly 0 argument(s)");
		return nullptr;
		}

#line 110 "pcap.bif"

	pcap_if_t* alldevs;
	char errbuf[PCAP_ERRBUF_SIZE];

	static auto ifaces_type = id::find_type<TableType>("Pcap::Interfaces");
	auto pcap_interfaces = make_intrusive<TableVal>(ifaces_type);

	int ret = pcap_findalldevs(&alldevs, errbuf);
	if ( ret == PCAP_ERROR )
		{
		emit_builtin_error(util::fmt("Error calling pcap_findalldevs: %s", errbuf));
		// Return an empty set in case of failure.
		return pcap_interfaces;
		}

	static auto iface_type = id::find_type<RecordType>("Pcap::Interface");
	for ( auto d = alldevs; d; d = d->next )
		{
		auto r = make_intrusive<RecordVal>(iface_type);

		r->Assign(0, d->name);
		if ( d->description )
			r->Assign(1, d->description);

		auto addrs = make_intrusive<ListVal>(TYPE_ADDR);
		for ( auto addr = d->addresses; addr != NULL; addr = addr->next )
			{
			if ( addr->addr->sa_family == AF_INET )
				{
				IPAddr a(reinterpret_cast<struct sockaddr_in *>(addr->addr)->sin_addr);
				addrs->Append(make_intrusive<AddrVal>(a));
				}
			else if ( addr->addr->sa_family == AF_INET6 )
				{
				IPAddr a(reinterpret_cast<struct sockaddr_in6 *>(addr->addr)->sin6_addr);
				addrs->Append(make_intrusive<AddrVal>(a));
				}
			}
		r->Assign(2, addrs->ToSetVal());
		r->Assign(3, static_cast<bool>(d->flags & PCAP_IF_LOOPBACK));
#ifdef PCAP_IF_UP
		// These didn't become available until libpcap 1.6.1
		r->Assign(4, static_cast<bool>(d->flags & PCAP_IF_UP));
		r->Assign(5, static_cast<bool>(d->flags & PCAP_IF_RUNNING));
#endif

		pcap_interfaces->Assign(std::move(r), nullptr);
		}

	pcap_freealldevs(alldevs);
	return pcap_interfaces;
	} // end of BifFunc::Pcap::findalldevs

#line 161 "pcap.bif"
